!   D02PDF Example Program Text
!   Mark 24 Release. NAG Copyright 2012.

    Module d02pdfe_mod

!     D02PDF Example Program Module:
!            Parameters and User-defined Routines

!     .. Use Statements ..
      Use nag_library, Only: nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Real (Kind=nag_wp), Parameter        :: tol1 = 1.0E-4_nag_wp
      Real (Kind=nag_wp), Parameter        :: tol2 = 1.0E-5_nag_wp
      Integer, Parameter                   :: neq = 2, nin = 5, nout = 6
      Integer, Parameter                   :: lenwrk = 32*neq
    Contains
      Subroutine f(t,y,yp)

!       .. Scalar Arguments ..
        Real (Kind=nag_wp), Intent (In)      :: t
!       .. Array Arguments ..
        Real (Kind=nag_wp), Intent (In)      :: y(*)
        Real (Kind=nag_wp), Intent (Out)     :: yp(*)
!       .. Executable Statements ..
        yp(1) = y(2)
        yp(2) = -y(1)
        Return
      End Subroutine f
    End Module d02pdfe_mod

    Program d02pdfe

!     D02PDF Example Main Program

!     .. Use Statements ..
      Use nag_library, Only: d02pdf, d02pvf, d02pyf, nag_wp
      Use d02pdfe_mod, Only: f, lenwrk, neq, nin, nout, tol1, tol2
!     .. Implicit None Statement ..
      Implicit None
!     .. Local Scalars ..
      Real (Kind=nag_wp)                   :: hnext, hstart, tend, tnow, tol,  &
                                              tstart, waste
      Integer                              :: i, ifail, method, stpcst,        &
                                              stpsok, totf
      Logical                              :: errass
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable      :: thres(:), work(:), ynow(:),      &
                                              ypnow(:), ystart(:)
!     .. Executable Statements ..
      Write (nout,*) 'D02PDF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) method
      Allocate (thres(neq),work(lenwrk),ynow(neq),ypnow(neq),ystart(neq))

!     Set initial conditions and input for D02PVF

      Read (nin,*) tstart, tend
      Read (nin,*) ystart(1:neq)
      Read (nin,*) hstart
      Read (nin,*) thres(1:neq)
      Read (nin,*) errass

      Do i = 1, 2
        If (i==1) tol = tol1
        If (i==2) tol = tol2


!       ifail: behaviour on error exit   
!              =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
        ifail = 0
        Call d02pvf(neq,tstart,ystart,tend,tol,thres,method,'Complex Task', &
          errass,hstart,work,lenwrk,ifail)

        Write (nout,99999) tol
        Write (nout,99998)
        Write (nout,99997) tstart, ystart(1:neq)

loop:   Do
          ifail = -1
          Call d02pdf(f,tnow,ynow,ypnow,work,ifail)

          If (ifail==0) Then
            Write (nout,99997) tnow, ynow(1:neq)
            If (tnow>=tend) Exit loop
          Else
            Exit loop
          End If

        End Do loop

        ifail = 0
        Call d02pyf(totf,stpcst,waste,stpsok,hnext,ifail)
        Write (nout,99996) totf
      End Do

99999 Format (/' Calculation with TOL = ',E8.1)
99998 Format (/'    t         y1        y2'/)
99997 Format (1X,F6.3,2(3X,F8.4))
99996 Format (/' Cost of the integration in evaluations of F is',I6)
    End Program d02pdfe
